local prefabs = {
    'nato556'
}
local assets = {
    Asset('ANIM', 'anim/m16a4.zip'),
    Asset('ANIM', 'anim/swap_m16a4.zip'),
    Asset('IMAGE', 'images/inventoryimages/M16A4.tex'),
    Asset('ATLAS', 'images/inventoryimages/M16A4.xml')
}
local projassets = {
    Asset('ANIM', 'anim/nato556proj.zip')
}

-----------------------------------------------------------------------------------------
--local dmg = 20
--local dmg_biantaiban=45
--local raidus = 12
--local radius_biantaiban=21
local clipsize = 30 --弹匣容量
-----------------------------------------------------------------------------------------

local function onrefuse(this, giver, item)
    if item.prefab == 'nato556' or item.prefab == "m16clip" then
        giver.components.talker:Say('30/30')
    else
        giver.components.talker:Say('方式不对')
    end
end
local function onequip(this, owner)
    owner.AnimState:OverrideSymbol('swap_object', 'swap_m16a4', 'swap_m16a4')
    owner.AnimState:Show('ARM_carry')
    owner.AnimState:Hide('ARM_normal')
end

local function onunequip(this, owner)
    owner.AnimState:Hide('ARM_carry')
    owner.AnimState:Show('ARM_normal')
end

local function m16AcceptTest(this, item)
    return
    (item.prefab == "nato556" or item.prefab == "m16clip")
    and (this.components.finiteuses:GetUses() < clipsize)
end

--SetRange(attack, hit)
--attack:发起攻击行为的半径
--hit:可以命中目标的的半径
------------------------------------------------------------------
local function m16a4_whatthefuck(this)
    this.components.weapon.SetDamage(170)
    this.components.weapon.SetRange(21, 21)
    this.components.weapon:SetProjectile('nato556proj')
end
local function m16_normal(this)
    local v = TUNING.FA
    this.components.weapon:SetDamage(v.DMG_M16)
    this.components.weapon:SetRange(v.RANGE_M16, v.RANGE_M16)
    this.components.weapon:SetProjectile('nato556proj')
end
------------------------------------------------------------------

local function onlaunch(this, weapon, target)
    print('[m16a4.lua] FUNC:onlaunch')
    weapon.SoundEmitter:PlaySound('fa/m16a4/fire')
    --local bullet = SpawnPrefab()
end

local function onattack_noammo(this, owner, target)
    this.components.finiteuses:SetUses(0)
    this.components.weapon:SetDamage(48)
    this.components.weapon:SetRange(1, 1)
    this.components.weapon:SetProjectile(nil)
    --print("无弹药")
end

local function onattack(this)
    if this.components.finiteuses:GetUses() <= 1 then
        this.components.weapon.onattack = onattack_noammo
        print('[M16A4.lua]\n\tonattack=onattack_noammo')
    end
    if TUNING.FA.BTMODE then
        m16_normal(this)
        if TUNING.FA.BTPlusMode then
            m16a4_whatthefuck(this)
        end
    else
        m16_normal(this)
    end
    --this.SoundEmitter:PlaySound('fa/m16a4/fire')
end

local function set_ranged(this)
    this.components.weapon:SetProjectile('nato556proj')
    this.components.weapon.onattack = onattack
    print('[M16A4.lua]onattack=onattack')
    ----------------------------------------
    m16_normal(this)
    ----------------------------------------
    if TUNING.FA.BTPlusMode then
        m16a4_whatthefuck(this)
    end
end

local function onaccept(this, giver, item)
    if this.components.finiteuses then

        if item.prefab == "m16clip" then
            local curclip = this.components.finiteuses:GetUses()
            this.components.finiteuses.SetUses(item.components.finiteuses:GetUses())
            item.components.finiteuses.SetUses(curclip)
            this:PushEvent('percentusedchange', {percent = this.components.finiteuses:GetPercent()})

            if this.components.finiteuses:GetUses() ~= 0 then
                set_ranged(this)
            end
        end

        if item.prefab == "nato556" then
            this.components.finiteuses.current = this.components.finiteuses.current + 1
            this:PushEvent('percentusedchange', {percent = this.components.finiteuses:GetPercent()})
            --先加current再推送一个事件，使HUD上的数字改变
            print('装弹后:'..tostring(this.components.finiteuses:GetUses()))
            set_ranged(this)
        end
    else
        print('[M16A4.lua]异常：传入的this没有finiteuses组件')
    end
end

local function onsave(this, data)
    data.ammocount = this.components.finiteuses:GetUses()
end

local function onload(this, data)
    if data.ammocount <= 0 then
        this.components.weapon.onattack = onattack_noammo
    else
        this.components.weapon.onattack = onattack
    end
end

local function ctor()
    print('[M16A4.lua] M16A4 ctor')
    local this = CreateEntity()
    this.entity:AddTransform()
    this.entity:AddAnimState()
    this.entity:AddLight()
    this.entity:AddSoundEmitter()
    this.entity:AddNetwork()
    MakeInventoryPhysics(this)
    this.AnimState:SetBuild('M16A4')
     --build.bin -> build_name
    this.AnimState:SetBank('m16a4')
     --anim.bin -> name
    this.AnimState:PlayAnimation('idle')
     --anim.bin -> animation.name

    this:AddComponent('finiteuses')
    this.components.finiteuses:SetMaxUses(clipsize)
     --clipsize=30
    this.components.finiteuses:SetUses(clipsize)

    this:AddTag('rangedweapon')
    this:AddTag('m16a4')

    this:AddComponent('inspectable')
    this.components.inspectable:SetDescription('一杆烧火棍')

    this:ListenForEvent('onthrown', function()this.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround)end)
    this.entity:SetPristine()
    ---------------------------------------------------------------
    if not TheWorld.ismastersim then
        return this
    end
    ------------------------主、客机执行分界线-----------------------
    this:AddComponent('weapon')
    this.components.weapon:SetOnProjectileLaunch(onlaunch)

    this:AddComponent('inventoryitem')
    this.components.inventoryitem.imagename = 'M16A4'
    this.components.inventoryitem.atlasname = 'images/inventoryimages/M16A4.xml'

    this:AddComponent('equippable')
    this.components.equippable:SetOnEquip(onequip)
    this.components.equippable:SetOnUnequip(onunequip)

    this:AddComponent('trader')
    this.components.trader:SetAcceptTest(m16AcceptTest)
    this.components.trader.onaccept = onaccept
    this.components.trader.onrefuse = onrefuse

    --ListenForEvent("m16reload",hasammo(this)) --没写对应的事件

    this.OnSave = onsave
    this.OnLoad = onload

	if TUNING.FA.BTPLUS then
		m16a4_whatthefuck(this)
    else
        m16_normal(this)
    end

    return this
end

local function projectlle_on_hit(this, attacker, target) --这个抄的
    local impactfx = SpawnPrefab('impact')
    if impactfx ~= nil then
        local follower = impactfx.entity:AddFollower()
        follower:FollowSymbol(target.GUID, target.components.combat.hiteffectsymbol, 0, 0, 0)
        if attacker ~= nil then
            impactfx:FacePoint(attacker.Transform:GetWorldPosition())
        end
    end
    print("[M16A4.lua] fn: on_hit, this:Remove")
    this:Remove()
end

local function ctor_nato556proj() --nato556proj构造函数
    local this = CreateEntity()
    print("[M16A4.lua] nato556 projectlle ctor")
    this.entity:AddTransform()
    this.entity:AddAnimState()
    this.entity:AddLight()
    this.entity:AddSoundEmitter()
    this.entity:AddNetwork()

    this.AnimState:SetBank('nato556proj')
    this.AnimState:SetBuild('nato556proj')
    this.AnimState:PlayAnimation("firing", true)
    this.Transform:SetScale(1, 2.5, 2)
     --参见 exported\nato556proj 这个工程

    MakeInventoryPhysics(this)

    --this.SoundEmitter:PlaySound("Fa/m16a4/firing")

    this:AddTag('NOCLICK')
    this.persists = false

    --this:AddTag("sharp")
    this:ListenForEvent('onthrown', function() this.AnimState:SetOrientation(ANIM_ORIENTATION.OnGround) end )
    this.entity:SetPristine()
    -----------------------------------------------
    if not TheWorld.ismastersim then
        return this
    end
    -----------------------------------------------
    this:AddComponent('projectile')
    this.components.projectile:SetSpeed(TUNING.FA.VELOCITY_556)
    this.components.projectile:SetOnHitFn(projectlle_on_hit)
	this.components.projectile:SetLaunchOffset(Vector3(2, 1.5, 0))

	--MakeHauntableLaunch(this)

    return this
end

return  Prefab('common/inventory/m16a4', ctor, assets),
        Prefab('nato556proj', ctor_nato556proj, projassets)
