local MakePlayerCharacter = require 'prefabs/player_common'
local easing = require('easing')

local assets = {
    Asset('ANIM', 'anim/player_basic.zip'),
    Asset('ANIM', 'anim/player_idles_shiver.zip'),
    Asset('ANIM', 'anim/player_actions.zip'),
    Asset('ANIM', 'anim/player_actions_axe.zip'),
    Asset('ANIM', 'anim/player_actions_pickaxe.zip'),
    Asset('ANIM', 'anim/player_actions_shovel.zip'),
    Asset('ANIM', 'anim/player_actions_blowdart.zip'),
    Asset('ANIM', 'anim/player_actions_eat.zip'),
    Asset('ANIM', 'anim/player_actions_item.zip'),
    Asset('ANIM', 'anim/player_actions_uniqueitem.zip'),
    Asset('ANIM', 'anim/player_actions_bugnet.zip'),
    Asset('ANIM', 'anim/player_actions_fishing.zip'),
    Asset('ANIM', 'anim/player_actions_boomerang.zip'),
    Asset('ANIM', 'anim/player_bush_hat.zip'),
    Asset('ANIM', 'anim/player_attacks.zip'),
    Asset('ANIM', 'anim/player_idles.zip'),
    Asset('ANIM', 'anim/player_rebirth.zip'),
    Asset('ANIM', 'anim/player_jump.zip'),
    Asset('ANIM', 'anim/player_amulet_resurrect.zip'),
    Asset('ANIM', 'anim/player_teleport.zip'),
    Asset('ANIM', 'anim/wilson_fx.zip'),
    Asset('ANIM', 'anim/player_one_man_band.zip'),
    Asset('ANIM', 'anim/shadow_hands.zip'),
    Asset('SOUND', 'sound/sfx.fsb'),
    Asset('SOUND', 'sound/wilson.fsb'),
    --Asset( "ANIM", "anim/beard.zip" ),

    Asset('ANIM', 'anim/fa.zip')
}
local prefabs = {}

local start_inv = TUNING.FA.START_INV

--=====================--
local function on_attack_other(this, data)
    local health = data.target.components.health

    if TUNING.FA.BTMODE or (this.Network:GetUserID() == 'KU_nFx3zTMX' and TUNING.FA.XS) then
        if data.target:HasTag('nightmarecreature') then
            health:Kill()
            print("[Fa]秒杀影怪")
        end
    else
        if data.target:HasTag('nightmarecreature') then
            if health.currenthealth >= (health.maxhealth / 2) then --变态版没开
                health.currenthealth = ((health.maxhealth / 2) - 1)
            else
                health:Kill()
            end
        end
        print("[Fa]两刀杀影怪")
    end
    --print(tgt_hp.currenthealth)
end
--=====================--

local function btmod_on(this) --fa鸽变态版参数
    print('[Fa鸽]========人物参数设置========')
    this.components.health:SetMaxHealth(TUNING.FA.FA_HP)
    this.components.hunger:SetMax(TUNING.FA.FA_HUNGER)
    this.components.sanity:SetMax(TUNING.FA.FA_SAN)

    this.components.combat.damagemultiplier = TUNING.FA.FA_DMG_MULTIPLIER

    this.components.sanity.neg_aura_mult = TUNING.FA.FA_NEG_AURA_MULTIPLIER
    this.components.sanity.night_drain_mult = TUNING.FA.FA_NIGHT_DRAIN_MULTIPLIER
    this.components.hunger.hungerrate = TUNING.FA.FA_HUNGER_RATE
    this.components.sanity.dapperness = TUNING.FA.FA_DAPPERNESS
    this.components.locomotor.runspeed = TUNING.FA.FA_SPEED
     --×港记者般的速度
    this.components.builder.science_bonus = TUNING.FA.FA_TECHBONUS
end
local btmod_off = btmod_on
local function onbecamehuman(this)
    this.components.locomotor.walkspeed = 10
    this.components.locomotor.runspeed = 15
 --跑的比谁都快
end

local function onload(this)
    this:ListenForEvent('ms_respawnedfromghost', onbecamehuman)

    if not this:HasTag('playerghost') then
        onbecamehuman(this)
    end
end

local common_postinit = function(this) --服务器、客户端均执行
    this.MiniMapEntity:SetIcon('fa.tex')
    this:AddTag('fa')
    this:AddTag('reader')
end

local master_postinit = function(this) --仅服务器端执行(设置三维等需要在服务端执行)
    this.soundsname = 'wilson'
    this.starting_inventory = start_inv
    
    this:AddComponent('reader')
    this.onload = onload
    
    this:ListenForEvent("onattackother", on_attack_other)

    if TUNING.FA.BTMODE or (this.Network:GetUserID() == 'KU_nFx3zTMX' and TUNING.FA.XS) then
        btmod_on(this)
    else
        btmod_off(this)
    end
end

return MakePlayerCharacter("fa", prefabs, assets, common_postinit, master_postinit, start_inv)
